import uuid

from flask import request
from flask import url_for


class MenuItem:
    def __init__(self, endpoint: str or None, name: str, menu_items=None, secure: bool = False):
        if menu_items is None:
            menu_items = []
        self._endpoint = endpoint
        self._name = name
        self._menu_items = menu_items
        self._id = uuid.uuid1()
        self._secure = secure

    def id(self):
        return self._id

    def name(self):
        return self._name

    def endpoint(self):
        return self._endpoint

    def menu_items(self):
        return self._menu_items

    def is_active(self):
        if request.endpoint == self._endpoint:
            return True

        try:
            return str.startswith(url_for(request.endpoint), url_for(self._endpoint))
        except:
            return False

    def is_secure(self):
        return self._secure
